require_relative "tracker/migration"
require_relative "tracker/registry"
require_relative "tracker/advisory_lock"

# module Tracker
#   extend Registry
#
#   def self.on(*args, &block)
#     Registry.on(*args, &block)
#   end
#
#   def self.track(*args, &block)
#     Registry.track(*args, &block)
#   end
#
#   extend Migration
#
#   class Event < ActiveRecord::Base
#     self.table_name = "tracker.events"
#
#     include AdvisoryLock
#
#     def self.track!(actions)
#       where(id: actions.map(&:id)).update_all(checked_out_at: Time.now)
#     end
#   end
#
#   def self.check_out_events
#     Event.exclusive do
#       event = Event.where("checked_out_at IS NULL OR checked_out_at < ?", Time.now - 10.minutes).order(:id).first
#       return [] unless event
#
#       if Registry.tracks?(event.table_name)
#         events = Event.where(table_name: event.table_name, entity_pkey: event.entity_pkey).to_a
#       else
#         events = [ event ]
#       end
#
#       Event.where(id: events.map(&:id)).update_all(checked_out_at: Time.now)
#       events
#     end
#   end
#
#   def self.check_all!
#     loop do
#       events = check_out_events
#       break if events.empty?
#
#       events.each do |event|
#         publish_event(event)
#       end
#
#       next if events.length == 1
#
#       # generate a table level event if necessary:
#       #
#       # A table level event is the last event, but only if the last event
#       # is not a delete where the accompanying "create" is also in the
#       # "events" array. In that case it would be the first entry
#
#       first_event = events.first
#       last_event = events.last
#       if first_event.action != "INSERT" && last_event.action != "DELETE"
#         publish_event(last_event, event_name: last_event.table_name)
#       end
#
#       destroyed = Event.where(id: events.map(&:id)).delete_all
#       puts "destroyed #{destroyed} events"
#     end
#   end
#
#   def self.publish_event(event, event_name: nil)
#     event_name ||= "#{event.table_name}.#{event.action.to_s.downcase}"
#     Registry.publish! event_name, event.entity_pkey, event.row_data, event.changed_fields, event
#   end
# end
#
# Tracker.migrate!
# Tracker.track_table! "public.posts"
#
# Tracker::Registry.reset!
#
# #
# # Is called after a posts entry was created
# Tracker.on "posts.insert" do |id, attrs|
#   puts "--> created post ##{id} with attrs #{attrs.inspect}"
# end
#
# #
# # Is called after a posts entry was destroyed. attrs contains
# # the previous attributes of the posts table.
# Tracker.on "posts.delete" do |id, attrs|
#   puts "--> deleted post ##{id} with attrs #{attrs.inspect}"
# end
#
# #
# # Is called whenever a post was changed. attrs contains the new
# # set of attributes, changed_attrs contains the changed attributes.
# Tracker.on "posts.update" do |id, attrs, changed_attrs|
#   puts "--> updated post ##{id} with attrs #{attrs.inspect}\n  changed_attrs: #{changed_attrs.inspect}"
# end
#
# post = Post.create! body: "bobo", author: User.first, group: User.first.wall
# post.update! body: "yiha"
# post.update! body: "banzai"
# post.destroy
#
# Tracker.check_all!
#
# #
# # Is called with the latest attrs for the "posts" entry.
# Tracker.track "posts" do |id, attrs|
#   puts "--> tracked post: id: #{id}, attrs: #{attrs}"
# end
#
# post = Post.create! body: "bobo", author: User.first, group: User.first.wall
# post.update! body: "yiha"
# post.update! body: "banzai"
# Tracker.check_all!
#
# post = Post.create! body: "bobo", author: User.first, group: User.first.wall
# Tracker.check_all!
#
# post.destroy
# Tracker.check_all!
