module Tracker
  module Migration
    class Options < OpenStruct
      def render(erb)
        erb.result(binding)
      end
    end

    def migrate!
      template = File.read(File.dirname(__FILE__) + "/tracker.sql")
      renderer = ERB.new(template)

      options = Options.new(reinstall: false)
      sql = options.render(renderer)
      ActiveRecord::Base.connection.execute sql
    end

    def track_table!(table)
      sql = "SELECT tracker.track_table('#{table}', 'id', array['created_at','updated_at', 'tsv', 'pg_search'])"
      ActiveRecord::Base.connection.execute sql
    end
  end
end
